import controlP5.*;
ControlP5 cp5;

import peasy.*;
//import peasy.org.apache.commons.math.*;
//import peasy.org.apache.commons.math.geometry.*;
//import peasy.test.*;

PeasyCam cam;

PeasyCam camera;

int numRows;

Table[] tables = new Table[10];
ArrayList<aurora> auroraVis = new ArrayList<aurora>();

float furGrowth = 3; 

int xo=0;
int yo=0;
int zo=0;

//***********for reference point***********
int xa=100;
int ya=-90;
int za=70;

float sphereSize = sqrt(sq(xa)+sq(ya)+sq(za));

boolean dateLable = false; 
boolean deweyLable = false; 
boolean test = false;
boolean Fur1;
boolean Fur2;
boolean Fur3;
boolean Fur4;
boolean Fur5;
boolean Fur6;
boolean Fur7;
boolean Fur8;
boolean Fur9;

//***********for points**********

float xp;
float yp;
float zp;

//*********for date lable***********
int i;
int a;

void setup() {
  size(1000, 760, P3D);
  //camera = new PeasyCam(this, 0, 0, 0, 50);
  cam = new PeasyCam(this, width/2, height/2, 0, 200);
  //cam.setMinimumDistance(500);
  //cam.setMaximumDistance(4000);

  for (int i=1; i<10; i++) {
    tables[i] = loadTable("Aurora_NL"+ i +".csv", "header");
  }

  for (int count = 1; count < 10; count++) {
    numRows = tables[count].getRowCount();
    //println("number of rowz:" + numRows);

    for (int i=0; i<numRows; i++) {
      String dates= tables[count].getString(i, 0);
      int checkOut= tables[count].getInt(i, 1);
      int dewey = tables[count].getInt(i, 2);
      int intensity = tables[count]. getInt(i, 3);
      //println(checkOut);

      auroraVis.add(new aurora(dates, checkOut, dewey, intensity, count));
    }
    //buttons();
  }

  //println("DATASize: " + auroraVis.size());
}
void draw() {
  background(0);
  translate(width/2, height/2);

  datePoints();

  //dateMode();
  //reference();
  if (Fur1) fur(1);
  if (Fur2) fur(2);
  if (Fur3) fur(3);
  if (Fur4) fur(4);
  if (Fur5) fur(5);
  if (Fur6) fur(6);
  if (Fur7) fur(7);
  if (Fur8) fur(8);
  if (Fur9) fur(9);

  if (dateLable) DateLable();
  if (deweyLable) DeweyLable(i, xp, yp, zp);
  if (test) Test();
}

void fur(int a) {

  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  text(a + "." + "table"+ (a + 2004), 30, (50+a*10));
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
  for (int i=0; i<auroraVis.size(); i++) {

    if (auroraVis.get(i).tablenumber == a) {

      float rho = map(auroraVis.get(i).checkOut, 8, 135, sphereSize, -sphereSize); 
      float phi = map(auroraVis.get(i).dewey, 1, 954, PI, -PI);
      float theta = map(monthParser(auroraVis.get(i).dates), 0, 12, 0, 2*PI);

      //println("rho:"+ rho);
      //println("phi:"+ phi);
      //println("theta:"+ theta);

      float x = rho * cos(theta) * sin(theta);
      float y = rho * sin(phi) * sin(theta);
      float z = rho * cos(phi);

      //println("x:"+ x);
      //println("y:"+ y);
      //println("z:"+ z);

      float xb = x * furGrowth;
      float yb = y * furGrowth;
      float zb = z * furGrowth;

      float r = random(255);
      float g = random(255);
      float b = random(255);

      //float r = 255;
      //float g = 255;
      //float b = 255;


      beginShape(LINES);
      stroke(r, b, g,60);
      strokeWeight(10);
      //vertex(0, 0, 0);
      vertex(x, y, z);
      vertex(xb, yb, zb);
      endShape();

      // *********Draw Dewey Points*******
      float rhoD = sphereSize;
      float phiD = map(auroraVis.get(i).dewey, 1, 954, PI, -PI);
      float thetaD = 2*PI;
      //float theta = monthParser(auroraVis.get(i).month) * PI/6;

      float xp = rhoD * cos(thetaD) * sin(phiD);
      float yp = rhoD * sin(phiD) * sin(thetaD);
      float zp = rhoD * cos(phiD);

      stroke(255, 255, 255, 100);
      strokeWeight(15);
      point(xp, yp, zp);
      pushMatrix();
      translate(xp, yp, zp);
      rotateX(PI/2);
      translate(-xp, -yp, -zp);
      //text(auroraVis.get(i).dewey, xp, yp, zp);
      if (deweyLable) DeweyLable(i, xp, yp, zp);
      popMatrix();
    }
  }
}


void datePoints() {
  float xp = 0; 
  float yp = 0; 
  float zp = 0; 

  for (int i=0; i<auroraVis.size(); i++) {

    //println("month: "+ str(monthParser(auroraVis.get(i).month)));

    float rho = sphereSize;
    //float phi = map(auroraVis.get(i).dewey, 1, 954, PI, -PI);
    float phi = PI/2;
    float theta = map(dateParser(auroraVis.get(i).dates), 0, 12, 0, 2*PI);
    //float theta = monthParser(auroraVis.get(i).month) * PI/6;

    xp = rho * cos(theta) * sin(phi);
    yp = rho * sin(phi) * sin(theta);
    zp = rho * cos(phi);

    stroke(255);
    strokeWeight(10);
    point(xp, yp, zp);
    //text(monthParser(auroraVis.get(i).dates), xp, yp, zp);
    //dateLable(i,xp, yp, zp);
  }
}